#include <windows.h>
#include <stdio.h>

#define WINDOW_NAME "AskMe 2.0"
#define BASE_PATH "Base\\"
#define MASK "*.txt"
#define PATH_SIZE 48
#define TITLE_SIZE 256
#define TASK_SIZE 2048
#define VARIANT_SIZE 512
#define DSCPLN_NUMBER 32
#define TOPICS_NUMBER 48
#define Q_NUMBER 1024
#define VAR_NUMBER 8
#define VENTRY_NUMBER 28
#define LEFT_MAX (VENTRY_NUMBER/2-1)
#define LEFT_START 0
#define RIGHT_START VENTRY_NUMBER/2

#define ID_MENUABOUT 10
#define ID_MENUINFO 11
#define ID_MENUHOTKEYS 12
#define ID_MENUDISCIPLINE 20
#define ID_TOPIC 100
#define ID_OWNEDOK 200
#define ID_MAINOK 300
#define ID_VARIANTSTART 1000
#define ID_NUM 10000

#define Y_START 10
#define MENU_HEIGHT 60
#define TOPIC_WIDTH 250
#define TOPIC_HEIGHT 60
#define TOPIC_COLUMNS 3
#define VAR_HEIGHT 20
#define OKBUTTON_HEIGHT 30
#define WINDOWTITLE_HEIGHT 30
#define SPACER 15
#define STRING_COEFFICIENT 0.6
#define MAX_STRING 8

class TitlePath
{
public:
	char title[TITLE_SIZE];
	char path[PATH_SIZE];
	bool loaded;
};

class vrnt
{
public:
	int GetCoefficient();
	bool loaded,correct;
	char text[VARIANT_SIZE];
};

class QuestionClass
{
public:
	QuestionClass();
	int GetSumCoefficient(int nUpTo);
	bool loaded, completed;
	int showed;
	char task[TASK_SIZE];
	vrnt variant[VAR_NUMBER];
};

class SingleVisualEntry
{
public:
	SingleVisualEntry();
	int qNumber;
	RECT task;
	RECT variants;
	HWND hVariant[VAR_NUMBER];
	HWND hOK;
	bool visible;
};

class Screen
{
public:
	Screen();
	void WM_PaintTask(HDC hDC);
	bool PlaceQuestion(int ToInsert, bool bReset);
	void InsertPosition(int nPosition);
	void HideAll();
	void RemoveInvisible();
	void Cleaner();
	HWND hWnd;
	RECT rMainWindow;
	int tmAveCharWidth;
	SingleVisualEntry Entry[VENTRY_NUMBER];
	int CurrentPosition;
};

LRESULT CALLBACK WndProc(HWND hWnd,UINT msg, WPARAM wParam,LPARAM lParam);
LRESULT CALLBACK OwnedProc(HWND hwnd, UINT Message, WPARAM wparam,LPARAM lparam);

void Init();
int LoadDisciplines(char szToSearch[PATH_SIZE]);
void ChooseTopic(TitlePath Ds);
void UnloadTopics();
void LoadQuestions(char szPath[PATH_SIZE]);
void UnloadQuestions();

bool CreateMenuItem(HMENU hMenu, char* str, UINT uID, UINT wID, HMENU hSubMenu);
int GetIDComponent(int nEnd);
int GetNextQuestion(int nStart);
void GetStat(int nLevel, bool bNeedMessage);

TitlePath Dscpln[DSCPLN_NUMBER];
TitlePath Topic[TOPICS_NUMBER];
QuestionClass Question[Q_NUMBER];
Screen OnScreen;
HINSTANCE hInst;
HFONT hCorrect,hMissing,hExcessive;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int iCmdShow)
{
MSG msg;
char ToSearch[PATH_SIZE];
int DCount;
HMENU hMainMenu;
HMENU hDscplnMenu;
HMENU hHelpMenu;

hInst=hInstance;
Init();
sprintf(ToSearch, "%s%s", BASE_PATH, MASK);
DCount=LoadDisciplines(ToSearch);

hMainMenu = CreateMenu();
hDscplnMenu = CreatePopupMenu();
hHelpMenu = CreatePopupMenu();
for (int i=0;i<=DCount;i++)
{
	CreateMenuItem(hDscplnMenu, Dscpln[i].title, 0, ID_MENUDISCIPLINE+i, NULL);
}
CreateMenuItem(hHelpMenu, "О программе", 1, ID_MENUABOUT, NULL);
CreateMenuItem(hHelpMenu, "Горячие клавиши", 1, ID_MENUHOTKEYS, NULL);
CreateMenuItem(hHelpMenu, "База данных", 1, ID_MENUINFO, NULL);
CreateMenuItem(hMainMenu, "Дисциплины", 0, 0, hDscplnMenu);
CreateMenuItem(hMainMenu, "Помощь", 1, 0, hHelpMenu);

OnScreen.hWnd = CreateWindowEx
	(0,
	"MainWClass",
	WINDOW_NAME,
	WS_OVERLAPPEDWINDOW,
	CW_USEDEFAULT,
	CW_USEDEFAULT,
	CW_USEDEFAULT,
	CW_USEDEFAULT,
	(HWND) NULL,
	(HMENU) hMainMenu,
	hInstance,
	NULL);
ShowWindow(OnScreen.hWnd,SW_MAXIMIZE);
UpdateWindow(OnScreen.hWnd);

TEXTMETRIC tmTM;
GetClientRect(OnScreen.hWnd,&OnScreen.rMainWindow);
HDC hDC=GetDC(OnScreen.hWnd);
GetTextMetrics(hDC,&tmTM);
ReleaseDC(OnScreen.hWnd,hDC);
OnScreen.tmAveCharWidth=tmTM.tmAveCharWidth;

ACCEL acc[VAR_NUMBER+2];
acc[0].key='1';
for(int i=0;i<VAR_NUMBER;i++)
{
	acc[i].cmd = ID_NUM+i;
	acc[i].fVirt = (BYTE)NULL;
	acc[i].key=acc[0].key+i;
}
acc[VAR_NUMBER].cmd = ID_MAINOK;
acc[VAR_NUMBER].fVirt = (BYTE)NULL;
acc[VAR_NUMBER].key = (char)13;

acc[VAR_NUMBER+1].cmd = ID_MAINOK;
acc[VAR_NUMBER+1].fVirt = (BYTE)NULL;
acc[VAR_NUMBER+1].key = (char)32;

HACCEL hAccel = CreateAcceleratorTable((LPACCEL)acc, VAR_NUMBER+2);

while(GetMessage(&msg,NULL,0,0))
{
	if(!(hAccel && TranslateAccelerator(OnScreen.hWnd, hAccel, &msg)))
	{
	TranslateMessage(&msg);
	DispatchMessage(&msg);
	}
}
DestroyAcceleratorTable(hAccel);
return msg.wParam;
}

LRESULT CALLBACK WndProc (HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
static int QCurrent=0;
static bool bFirst=TRUE;

switch(msg)
{
case WM_PAINT:
{
	HDC hDC;
	PAINTSTRUCT ps;
	hDC=BeginPaint(hWnd,&ps);
	OnScreen.WM_PaintTask(hDC);
	EndPaint(hWnd,&ps);
}
break;

case WM_COMMAND:
{
for(int i=0;i<=DSCPLN_NUMBER;i++)
{
	if((LOWORD(wParam)==ID_MENUDISCIPLINE+i)&&(Dscpln[i].loaded))
	{
	UnloadTopics();
	ChooseTopic(Dscpln[i]);
	}
}

for(int i=0;i<VAR_NUMBER;i++)
{
	if((LOWORD(wParam)==ID_NUM+i)&&(bFirst))
	{
	int nIDComponent=GetIDComponent(QCurrent);
	for(int j=0;j<VAR_NUMBER;j++)
	{
		if((Question[QCurrent].variant[j].loaded)&&(i==j))
		{
		HWND hwndCheck = GetDlgItem(hWnd, ID_VARIANTSTART+nIDComponent+j);
		LRESULT res = SendMessage (hwndCheck, BM_GETCHECK, 0, 0);
		if(res == BST_CHECKED) SendMessage (hwndCheck, BM_SETCHECK, BST_UNCHECKED, 0);
		else SendMessage (hwndCheck, BM_SETCHECK, BST_CHECKED, 0);
		}
	}
	}
}

if(!bFirst)
{
int nIDComponent=GetIDComponent(QCurrent);
for(int i=0;i<VAR_NUMBER;i++)
{
	if(LOWORD(wParam)==(ID_VARIANTSTART+nIDComponent+i))
	{
		HWND hwndCheck = GetDlgItem(hWnd, ID_VARIANTSTART+nIDComponent+i);
		LRESULT res = SendMessage (hwndCheck, BM_GETCHECK, 0, 0);
		if(res == BST_CHECKED) SendMessage (hwndCheck, BM_SETCHECK, BST_UNCHECKED, 0);
		else SendMessage (hwndCheck, BM_SETCHECK, BST_CHECKED, 0);
	}
}
}

if(LOWORD(wParam)==ID_MENUABOUT)
{
char s[]="Программа для подготовки к тестированию \"AskMe 2.0\".\nДомашняя страница: http://mmaketchup.narod.ru/additional.htm\nПрограмма распространяется по лицензии GPL\nПожелания и предложения напрявляйте на e-mail: mmaketchup@mail.ru.\n\nАвтор - Ketchup.\nСентябрь 2006.";
MessageBox(OnScreen.hWnd,s,"О программе",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
}

if(LOWORD(wParam)==ID_MENUHOTKEYS)
{
char s[]="Для выбора ответа используйте клавиши 1-7 на дополнительной (включите NumLock) или основной клавиатуре\nНажать кнопку \"OK\" можно пробелом или \"Enter\"";
MessageBox(OnScreen.hWnd,s,"Горячие клавиши",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
}

if(LOWORD(wParam)==ID_MENUINFO)
{
char s[]="Формат базы:\nКаждый вопрос состоит из задания и вариантов ответа. На задание и варианты отводится по 1 строчке. Перед каждым вариантом стоит символ табуляции: (char)9\nКаждая дисциплина расположена в отдельной директории.\nОписание содержимого директории находится в файле \"Base\\x.txt\", где x - порядковый номер дисциплины\nВ файле-описании первая строчка отведена под название дисциплины. Далее идут строчки описания следующего формата: символ табуляции, затем название темы, далее в кавычках относительный путь к файлу с вопросами темы\nКодировка всех файлов: Windows-1251";
MessageBox(OnScreen.hWnd,s,"Информация",MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
}

if (LOWORD(wParam)==ID_MAINOK)
{
static int nCycle=1;
static bool bOK=1;
int nIDComponent=GetIDComponent(QCurrent);
	for(int i=0;i<VAR_NUMBER;i++)
	{
	if(Question[QCurrent].variant[i].loaded)
	{
		HWND hwndCheck = GetDlgItem(hWnd, ID_VARIANTSTART+nIDComponent+i);
		if(bFirst)
		{
		LRESULT res = SendMessage (hwndCheck, BM_GETCHECK, 0, 0);
		if((res == BST_CHECKED)&(Question[QCurrent].variant[i].correct))
			{SendMessage (hwndCheck, WM_SETFONT, (WPARAM)hCorrect, 1);}
		if((res == BST_CHECKED)&(!Question[QCurrent].variant[i].correct))
			{bOK=FALSE;SendMessage (hwndCheck, WM_SETFONT, (WPARAM)hExcessive, 1);}
		if((res == BST_UNCHECKED)&(Question[QCurrent].variant[i].correct))
			{bOK=FALSE;SendMessage (hwndCheck, WM_SETFONT, (WPARAM)hMissing, 1);}
		}
		else EnableWindow(hwndCheck,0);
	}
	}
	if((bOK)&&(bFirst)) Question[QCurrent].completed=1;
	if(bFirst) GetStat(nCycle,0);

	if(!bFirst)
	{
		bOK=TRUE;
		QCurrent=GetNextQuestion(QCurrent+1);
		if((QCurrent==-1)&&Question[0].loaded)
			{
			GetStat(nCycle,1);
			nCycle++;
			OnScreen.HideAll();
			OnScreen.RemoveInvisible();
			SetWindowText(hWnd,WINDOW_NAME);
			QCurrent=GetNextQuestion(QCurrent+1);
			if(QCurrent==-1)
				{
				MessageBox(NULL,"Game over","Game over",MB_OK);
				nCycle=1;
				OnScreen.HideAll();
				OnScreen.RemoveInvisible();
				SetWindowText(hWnd,WINDOW_NAME);
				}
			}
		OnScreen.PlaceQuestion(QCurrent,0);
	}
	bFirst=!bFirst;
}
return -1;
}

case (WM_USER):
{
	OnScreen.HideAll();
	OnScreen.RemoveInvisible();
	OnScreen.Cleaner();
	QCurrent=0;
	bFirst=TRUE;
	SetWindowText(hWnd,WINDOW_NAME);
	OnScreen.PlaceQuestion(QCurrent,1);
}
break;

case WM_DESTROY:
PostQuitMessage(0);
break;

default:
return DefWindowProc(hWnd,msg,wParam,lParam);
}

return 0;
}

LRESULT CALLBACK OwnedProc (HWND hwnd, UINT Message, WPARAM wparam, LPARAM lparam)
{
switch (Message)
{

case WM_CREATE:
{
	EnableWindow(OnScreen.hWnd,0);
	EnableWindow(hwnd,1);
}
break;

case WM_COMMAND:
{
if(LOWORD(wparam)==ID_OWNEDOK)
{
bool bChosen=FALSE;
for(int i=0;i<TOPICS_NUMBER;i++)
{
	if (Topic[i].loaded)
	{
	HWND hwndCheck = GetDlgItem(hwnd, i+ID_TOPIC);
	LRESULT res = SendMessage (hwndCheck, BM_GETCHECK, 0, 0);
	if(res==BST_CHECKED) {UnloadQuestions();LoadQuestions(Topic[i].path);bChosen=TRUE;}
	}
}
if(bChosen) PostMessage(OnScreen.hWnd,WM_USER,0,0);
DestroyWindow(hwnd);
}
return -1;
}
break;

case WM_DESTROY:
{
	EnableWindow(OnScreen.hWnd,1);
	BringWindowToTop(OnScreen.hWnd);
	return 0;
}
break;

default:
	return DefWindowProc(hwnd,Message,wparam,lparam);
}
}

void Init()
{
WNDCLASSEX wc;
WNDCLASS w;
hCorrect=CreateFont(
	0,			// height of font
	0,			// average character width
	0,			// angle of escapement
	0,			// base-line orientation angle
	700,			// font weight
	0,			// italic attribute option
	0,			// underline attribute option
	0,			// strikeout attribute option
	OEM_CHARSET,		// character set identifier
	OUT_DEFAULT_PRECIS,	// output precision
	CLIP_DEFAULT_PRECIS,	// clipping precision
	DEFAULT_QUALITY,	// output quality
	DEFAULT_PITCH,		// pitch and family
	NULL			// typeface name
	);
hMissing=CreateFont(
	0,			// height of font
	0,			// average character width
	0,			// angle of escapement
	0,			// base-line orientation angle
	700,			// font weight
	0,			// italic attribute option
	1,			// underline attribute option
	0,			// strikeout attribute option
	OEM_CHARSET,		// character set identifier
	OUT_DEFAULT_PRECIS,	// output precision
	CLIP_DEFAULT_PRECIS,	// clipping precision
	DEFAULT_QUALITY,	// output quality
	DEFAULT_PITCH,		// pitch and family
	NULL			// typeface name
	);
hExcessive=CreateFont(
	0,			// height of font
	0,			// average character width
	0,			// angle of escapement
	0,			// base-line orientation angle
	400,			// font weight
	0,			// italic attribute option
	0,			// underline attribute option
	1,			// strikeout attribute option
	OEM_CHARSET,		// character set identifier
	OUT_DEFAULT_PRECIS,	// output precision
	CLIP_DEFAULT_PRECIS,	// clipping precision
	DEFAULT_QUALITY,	// output quality
	DEFAULT_PITCH,		// pitch and family
	NULL			// typeface name
	);

wc.cbSize=sizeof(wc);
wc.cbClsExtra=0;
wc.cbWndExtra=0;
wc.hbrBackground=(HBRUSH)COLOR_BTNSHADOW;
wc.hCursor=LoadCursor(0,IDC_ARROW);
wc.hIcon=LoadIcon(hInst,IDI_APPLICATION);
wc.hIconSm=LoadIcon(hInst,IDI_APPLICATION);
wc.hInstance=hInst;
wc.lpfnWndProc=WndProc;
wc.lpszClassName="MainWClass";
wc.lpszMenuName=NULL;
wc.style=CS_HREDRAW | CS_VREDRAW;
RegisterClassEx(&wc);

memset(&w,0,sizeof(WNDCLASS));
w.lpfnWndProc = OwnedProc;
w.hInstance = hInst;
w.hbrBackground = (HBRUSH)COLOR_BTNSHADOW;
w.lpszClassName = "OwnedWClass";
w.hCursor=LoadCursor(NULL,IDC_CROSS); 
RegisterClass(&w);
}

int LoadDisciplines(char szToSearch[PATH_SIZE])
{
WIN32_FIND_DATA FindFileData;
HANDLE hFind;
HANDLE hFile;
DWORD dwNumRead;
bool bWorking=1;
int DCount=0,i=0;
char ch;

hFind=FindFirstFile(szToSearch, &FindFileData);
sprintf(Dscpln[DCount].path, "%s%s", BASE_PATH, FindFileData.cFileName);
hFile=CreateFile(
	Dscpln[DCount].path,
	GENERIC_READ,
	FILE_SHARE_READ,
	NULL,
	OPEN_EXISTING,
	FILE_ATTRIBUTE_NORMAL,
	NULL);

ReadFile(hFile, &ch, 1, &dwNumRead,NULL);
while(ch!=(char)13)
{
	Dscpln[DCount].title[i]=ch;
	ReadFile(hFile, &ch, 1, &dwNumRead,NULL);
	i++;
}
Dscpln[DCount].loaded=1;
CloseHandle(hFile);
while (bWorking=FindNextFile(hFind, &FindFileData)!=FALSE)
	{
	DCount++;
	sprintf(Dscpln[DCount].path, "%s%s", BASE_PATH, FindFileData.cFileName);
	hFile=CreateFile(
		Dscpln[DCount].path,
		GENERIC_READ,
		FILE_SHARE_READ,
		NULL,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,
		NULL);
	i=0;
	ReadFile(hFile, &ch, 1, &dwNumRead,NULL);
	while(ch!=(char)13)
	{
		Dscpln[DCount].title[i]=ch;
		ReadFile(hFile, &ch, 1, &dwNumRead,NULL);
		i++;
	}
	Dscpln[DCount].loaded=1;
	CloseHandle(hFile);
	}
FindClose(hFind);
return DCount;
}

void ChooseTopic(TitlePath Discipline)
{
HANDLE hFile;
char ch;
DWORD dwNumRead;
bool bTitle=FALSE,bPath=FALSE;
int nTCount=-1,i=0;
HWND hOwned;

hFile=CreateFile(
	Discipline.path,
	GENERIC_READ,
	FILE_SHARE_READ,
	NULL,
	OPEN_EXISTING,
	FILE_ATTRIBUTE_NORMAL,
	NULL);
do
{
	ReadFile(hFile,&ch,1,&dwNumRead,NULL);
	if(ch==(char)9) {bTitle=true;nTCount++;Topic[nTCount].loaded=TRUE;}
	if(ch=='\"') {bTitle=!bTitle;bPath=!bPath;i=0;}
	if(
		(bTitle)&
		(ch!=(char)9)&
		(ch!=(char)10)&
		(ch!=(char)13)&
		(ch!='\"')
	)
	{Topic[nTCount].title[i]=ch;i++;}
	if(
		(bPath)&
		(ch!='\"')
	)
	{Topic[nTCount].path[i]=ch;i++;}
}
while(dwNumRead!=0);
CloseHandle(hFile);

for(i=0;i<=nTCount;i++)
{
	char tmp[PATH_SIZE];
	sprintf(tmp,"%s%s",BASE_PATH,Topic[i].path);
	strcpy(Topic[i].path,tmp);
}

int nOKButtonPos=SPACER+((nTCount-(nTCount+TOPIC_COLUMNS)%TOPIC_COLUMNS)*TOPIC_HEIGHT)/TOPIC_COLUMNS;
nOKButtonPos+=TOPIC_HEIGHT;
const int nHeight=WINDOWTITLE_HEIGHT+nOKButtonPos+OKBUTTON_HEIGHT+SPACER;
const int nTop=(OnScreen.rMainWindow.bottom-nHeight)/2;
const int nWidth=TOPIC_WIDTH*TOPIC_COLUMNS+SPACER+TOPIC_COLUMNS*SPACER;
const int nLeft=(OnScreen.rMainWindow.right-nWidth)/2;

hOwned=CreateWindowEx(
	0,
	"OwnedWClass",
	Discipline.title,
	WS_OVERLAPPEDWINDOW,
	nLeft,
	nTop,
	nWidth,
	nHeight,
	OnScreen.hWnd,
	NULL,
	hInst,
	NULL);
for(i=0;i<=nTCount;i++)
{
	CreateWindow(
	"button",
	Topic[i].title,
	WS_CHILD|WS_VISIBLE|BS_AUTORADIOBUTTON|BS_MULTILINE,
	SPACER+(TOPIC_WIDTH+SPACER)*((i+TOPIC_COLUMNS)%TOPIC_COLUMNS),
	SPACER+((i-(i+TOPIC_COLUMNS)%TOPIC_COLUMNS)*TOPIC_HEIGHT)/TOPIC_COLUMNS,
	TOPIC_WIDTH,
	TOPIC_HEIGHT,
	hOwned,
	(HMENU)(ID_TOPIC+i),
	hInst,
	NULL);
}
CreateWindow(
	"button",
	"OK",
	WS_CHILD|WS_VISIBLE,
	SPACER,
	nOKButtonPos,
	nWidth-2*SPACER,
	OKBUTTON_HEIGHT,
	hOwned,
	(HMENU)ID_OWNEDOK,
	hInst,
	NULL);
ShowWindow(hOwned,SW_SHOW);
UpdateWindow(hOwned);
}

void UnloadTopics()
{
int i,j;
for(i=0;i<TOPICS_NUMBER;i++)
{
	Topic[i].loaded=FALSE;
	for(j=0;j<TITLE_SIZE;j++) Topic[i].title[j]=(char)NULL;
	for(j=0;j<PATH_SIZE;j++) Topic[i].path[j]=(char)NULL;
}
}

void LoadQuestions(char szPath[PATH_SIZE])
{
DWORD NumRead;
HANDLE hFile;
char ch;
bool new_str=1,istask,visible;
int i,j;
int QCount=-1;

hFile=CreateFile(
	szPath,
	GENERIC_READ,
	FILE_SHARE_READ,
	NULL,
	OPEN_EXISTING,
	FILE_ATTRIBUTE_NORMAL,
	NULL);
do
{
	visible=TRUE;
	ReadFile(hFile,&ch,1,&NumRead,NULL);
	if(new_str)
	{
		if (ch==(char)9) {istask=FALSE;j++;Question[QCount].variant[j].loaded=1;i=0;}
		else {istask=true;QCount++;Question[QCount].loaded=1;j=-1;i=0;}
		new_str=false;
	}
	if(ch==(char)10) {new_str=true;}
	if(ch==(char)13|(ch==(char)10)){visible=FALSE;}
	if((istask)&(visible)) {Question[QCount].task[i]=ch;i++;}
	else
	{
		if((ch=='+')&(i==0)){Question[QCount].variant[j].correct=1;visible=FALSE;}
		if((ch=='-')&(i==0)){Question[QCount].variant[j].correct=0;visible=FALSE;}
		if((ch==(char)9)|(ch==(char)10)|(ch==(char)13)){visible=FALSE;}
		if(visible){Question[QCount].variant[j].text[i]=ch;i++;}
	}
}
while(NumRead!=0);
}

void UnloadQuestions()
{
int i,j,k;
for(i=0;i<Q_NUMBER;i++)
{
	Question[i].loaded=FALSE;
	Question[i].completed=FALSE;
	Question[i].showed=0;
	for(j=0;j<TASK_SIZE;j++) Question[i].task[j]=(char)NULL;
	for(j=0;j<VAR_NUMBER;j++)
	{
		Question[i].variant[j].loaded=FALSE;
		Question[i].variant[j].correct=FALSE;
		for(k=0;k<VARIANT_SIZE;k++) Question[i].variant[j].text[k]=(char)NULL;
	}
}
}

bool CreateMenuItem
	(
	HMENU hMenu,
	char* str,
	UINT uID,
	UINT wID,
	HMENU hSubMenu
	)
{
MENUITEMINFO mi;
mi.cbSize = sizeof(MENUITEMINFO);
mi.fMask = MIIM_STATE|MIIM_TYPE|MIIM_SUBMENU|MIIM_ID;
mi.fType = MFT_STRING;
mi.fState = MFS_ENABLED;
mi.dwTypeData = str;
mi.cch = sizeof(str);
mi.wID = wID;
mi.hSubMenu = hSubMenu;
return InsertMenuItem(hMenu, uID, FALSE, &mi);
}

int GetIDComponent(int nEnd)
{
int nIDComponent=0;
for(int i=0;i<nEnd;i++)
{
	for(int j=0;j<VAR_NUMBER;j++) {if(Question[i].variant[j].loaded) nIDComponent++;}
}
return nIDComponent;
}

int GetNextQuestion(int nStart)
{
int i;
bool bEnd=1;
for(i=nStart;i<Q_NUMBER;i++)
	{
	if((!Question[i].completed)&&Question[i].loaded) return i;
	}
return -1;
}

void GetStat(int nLevel, bool bNeedMessage)
{
int nSeen=0,nCorrect=0,nLeft=0;
float fProcent;
char szResult[32];
for(int i=0;i<Q_NUMBER;i++)
{
if(Question[i].loaded)
{
	if(Question[i].showed==nLevel)
	{
		nSeen++;
		if(Question[i].completed) nCorrect++;
	}
	if(((Question[i].showed==nLevel-1)|(Question[i].showed==0))&&(!Question[i].completed)) nLeft++;
}
}
fProcent=nCorrect;
if(nSeen!=0) fProcent=(fProcent/nSeen)*100;
else fProcent=0;
sprintf(szResult,"Правильно %3.3f %%, осталось %d", fProcent,nLeft);
SetWindowText(OnScreen.hWnd,szResult);
if(bNeedMessage)
{
	sprintf(szResult,"Правильных %d, всего %d (%3.3f %%)", nCorrect,nSeen,fProcent);
	MessageBox(OnScreen.hWnd,szResult,"Statistics",MB_OK);
}
}

QuestionClass::QuestionClass()
{
loaded=FALSE;
showed=0;
completed=FALSE;
}

SingleVisualEntry::SingleVisualEntry()
{
	for(int i=0;i<VAR_NUMBER;i++) hVariant[i]=NULL;
	hOK=NULL;
	qNumber=-1;
	task.left=0;
	task.right=0;
	task.top=0;
	task.bottom=0;
	variants.left=0;
	variants.right=0;
	variants.top=0;
	variants.bottom=0;
	visible=FALSE;
}

int vrnt::GetCoefficient()
{
float fChar,fCoefficient;
int nCoefficient=1;

fChar=(OnScreen.rMainWindow.right/2);
fChar=fChar/OnScreen.tmAveCharWidth;
fCoefficient=strlen(text);
fCoefficient=fCoefficient/fChar;
for(int i=1;i<MAX_STRING;i++) {if(fCoefficient>(STRING_COEFFICIENT*i)) nCoefficient=i+1;}
return nCoefficient;
}

int QuestionClass::GetSumCoefficient(int nUpTo)
{
int nSum=0;
for(int i=0;i<nUpTo;i++) nSum+=variant[i].GetCoefficient();
return nSum;
}

Screen::Screen()
{
	CurrentPosition=-1;
}

void Screen::WM_PaintTask(HDC hDC)
{
SetBkMode(hDC,TRANSPARENT);
for(int i=0;i<VENTRY_NUMBER;i++)
{
if(Entry[i].visible)
DrawText(
	hDC,
	Question[Entry[i].qNumber].task,
	strlen(Question[Entry[i].qNumber].task),
	&Entry[i].task,
	DT_WORDBREAK);
}
}

bool Screen::PlaceQuestion(int ToInsert, bool bReset)
{
static int nID=ID_VARIANTSTART;
if(bReset) nID=ID_VARIANTSTART-1;

RECT tmp;
int nTaskHeight,nVariantsHeight,nVarCount=0,nIDComponent=0;
HDC hDC;
int nCoefficient=1;
float fCoefficient,fChar;

if(ToInsert==-1) return 0;

tmp.left=0;
tmp.right=rMainWindow.right/2;
tmp.top=0;
tmp.bottom=SPACER;

hDC=GetDC(hWnd);
DrawText(hDC, Question[ToInsert].task, strlen(Question[ToInsert].task), &tmp, DT_CALCRECT|DT_WORDBREAK);
ReleaseDC(hWnd,hDC);

nTaskHeight=tmp.bottom-tmp.top;
nTaskHeight+=SPACER;

nVariantsHeight=0;
for(int i=0;i<VAR_NUMBER;i++)
{
	if(Question[ToInsert].variant[i].loaded)
		nVariantsHeight+=Question[ToInsert].variant[i].GetCoefficient()*VAR_HEIGHT;
}

CurrentPosition++;
if(CurrentPosition==VENTRY_NUMBER) CurrentPosition=0;

if(CurrentPosition!=0)
{
if(
	(Entry[CurrentPosition-1].variants.bottom
	+nTaskHeight
	+nVariantsHeight
	+OKBUTTON_HEIGHT)
	>(rMainWindow.bottom-Y_START))
	{if((CurrentPosition<=LEFT_MAX)|(CurrentPosition==RIGHT_START))
		CurrentPosition=RIGHT_START;
	else CurrentPosition=LEFT_START;}
}

if(CurrentPosition!=0)
{
if((Entry[CurrentPosition-1].variants.bottom
	+nTaskHeight
	+nVariantsHeight
	+OKBUTTON_HEIGHT)<Entry[CurrentPosition].task.top)
	{InsertPosition(CurrentPosition);}
}
Entry[CurrentPosition].visible=FALSE;
RemoveInvisible();

if((CurrentPosition==LEFT_START)|(CurrentPosition==RIGHT_START)) Entry[CurrentPosition].task.top=Y_START;
else Entry[CurrentPosition].task.top=Entry[CurrentPosition-1].variants.bottom;

Entry[CurrentPosition].task.bottom=Entry[CurrentPosition].task.top+nTaskHeight;
Entry[CurrentPosition].variants.top=Entry[CurrentPosition].task.bottom;
Entry[CurrentPosition].variants.bottom=Entry[CurrentPosition].variants.top+nVariantsHeight;

if(CurrentPosition<=LEFT_MAX)
{
Entry[CurrentPosition].task.left=Entry[CurrentPosition].variants.left=SPACER;
Entry[CurrentPosition].task.right=Entry[CurrentPosition].variants.right=rMainWindow.right/2;
}
else
{
Entry[CurrentPosition].task.left=Entry[CurrentPosition].variants.left=SPACER+rMainWindow.right/2;
Entry[CurrentPosition].task.right=Entry[CurrentPosition].variants.right=rMainWindow.right;
}

Entry[CurrentPosition].visible=1;
Entry[CurrentPosition].qNumber=ToInsert;

for(int i=1;i<VENTRY_NUMBER/2;i++)
{
	if(CurrentPosition!=(VENTRY_NUMBER-i))
	{
	if
	(
		((CurrentPosition<=LEFT_MAX)&&(CurrentPosition+i)<=LEFT_MAX)|
		((CurrentPosition>=RIGHT_START)&&(CurrentPosition+i)>=RIGHT_START)
	)
	{
	if((Entry[CurrentPosition].variants.bottom+OKBUTTON_HEIGHT)>Entry[CurrentPosition+i].task.top)
		Entry[CurrentPosition+i].visible=FALSE;
	}
	}
}
RemoveInvisible();

hDC=GetDC(hWnd);
SetBkMode(hDC,TRANSPARENT);
DrawText
	(hDC,
	Question[ToInsert].task,
	strlen(Question[ToInsert].task),
	&Entry[CurrentPosition].task,
	DT_WORDBREAK);
ReleaseDC(hWnd,hDC);

for(int i=0;i<VAR_NUMBER;i++)
{
	if(Question[Entry[CurrentPosition].qNumber].variant[i].loaded)
	{
		if(Question[Entry[CurrentPosition].qNumber].showed!=0)
		{
		nIDComponent=GetIDComponent(Entry[CurrentPosition].qNumber);
		nID=ID_VARIANTSTART-1+nIDComponent+nVarCount;
		}
	nID++;
	Entry[CurrentPosition].hVariant[i]=
		CreateWindow
		("button",
		Question[Entry[CurrentPosition].qNumber].variant[i].text,
		WS_CHILD|WS_VISIBLE|BS_AUTOCHECKBOX|BS_MULTILINE,
		Entry[CurrentPosition].variants.left,
		Entry[CurrentPosition].variants.top+
		VAR_HEIGHT*Question[Entry[CurrentPosition].qNumber].GetSumCoefficient(i),
		Entry[CurrentPosition].variants.right-Entry[CurrentPosition].variants.left,
		VAR_HEIGHT*Question[Entry[CurrentPosition].qNumber].variant[i].GetCoefficient(),
		hWnd,
		(HMENU)nID,
		hInst,
		NULL);
	nVarCount++;
	}
}
Entry[CurrentPosition].hOK=CreateWindow(
	"button",
	"OK",
	WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
	Entry[CurrentPosition].variants.left,
	Entry[CurrentPosition].variants.top+
	VAR_HEIGHT*Question[Entry[CurrentPosition].qNumber].GetSumCoefficient(nVarCount),
	rMainWindow.right/2-2*SPACER,
	OKBUTTON_HEIGHT,
	hWnd,
	(HMENU)ID_MAINOK,
	hInst,
	NULL);
Question[Entry[CurrentPosition].qNumber].showed++;
return 1;
}

void Screen::InsertPosition(int nPosition)
{
int nStart;
if(nPosition<LEFT_MAX) nStart=LEFT_MAX;
else if(nPosition>RIGHT_START) nStart=VENTRY_NUMBER-1;
else nStart=0;
for(int i=nStart;i>nPosition;i--)
{
	Entry[i].qNumber=Entry[i-1].qNumber;
	Entry[i].task=Entry[i-1].task;
	Entry[i].variants=Entry[i-1].variants;
	Entry[i].visible=Entry[i-1].visible;
	for(int j=0;j<VAR_NUMBER;j++)
	{
		Entry[i].hVariant[j]=Entry[i-1].hVariant[j];
	}
	Entry[i].hOK=Entry[i-1].hOK;
}
	for(int j=0;j<VAR_NUMBER;j++)
	{
		Entry[nPosition].hVariant[j]=NULL;
	}
	Entry[nPosition].hOK=NULL;
}

void Screen::HideAll()
{
for(int i=0;i<VENTRY_NUMBER;i++)
	{
	Entry[i].visible=FALSE;
	}
CurrentPosition=-1;
}

void Screen::RemoveInvisible()
{
for(int i=0;i<VENTRY_NUMBER;i++)
{
	if(!Entry[i].visible)
	{
	InvalidateRect(hWnd, &Entry[i].task,1);
	for(int j=0;j<VAR_NUMBER;j++)
	{
		if(Question[Entry[i].qNumber].variant[j].loaded)
		{
		if(Entry[i].hVariant[j]!=NULL) {DestroyWindow(Entry[i].hVariant[j]);Entry[i].hVariant[j]=NULL;}
		}
	}
	}
	if(i!=CurrentPosition)
	{
	if(Entry[i].hOK!=NULL) {DestroyWindow(Entry[i].hOK);Entry[i].hOK=NULL;}
	}
	UpdateWindow(hWnd);
}
}

void Screen::Cleaner()
{
HWND hWndFind;
do
{
	hWndFind=GetWindow(hWnd,GW_CHILD);
	if(hWndFind!=NULL) DestroyWindow(hWndFind);
}
while(hWndFind!=NULL);
}
